// ChatClient.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "FileLog.h"
#include "SocketClient.h"
#include "ChatClient.h"
#include <shellapi.h>

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
_TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
_TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

_TCHAR szProfile[MAX_PATH];
SocketClient socketClient;
CFileLog fileLog;
WNDPROC wpOrigProcPort;
WNDPROC wpOrigProcHost;

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CHATCLIENT, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_CHATCLIENT));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}
	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= DLGWINDOWEXTRA;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CHATCLIENT));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_GRAYTEXT); //(COLOR_WINDOW+1); COLOR_BTNHIGHLIGHT
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_CHATCLIENT);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   /*hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);*/
	hWnd = CreateDialog(hInstance, MAKEINTRESOURCE(IDD_CLIENTDLG), NULL, NULL);
	SetWindowText(hWnd, szTitle);

   if (!hWnd)
   {
      return FALSE;
   }

   	//   -	
   ::_tsetlocale(LC_ALL, LOCAL_LOC);
   ::LoadKeyboardLayout(KLID_LOC, KLF_ACTIVATE);

	_TCHAR szPath[MAX_PATH];
	bool bIsFileName = false;
	bool bIsProfile = false;
	if (::GetModuleFileName(NULL, szPath, MAX_PATH) != 0)
	{
		_TCHAR* lpchLastBS = ::_tcsrchr(szPath, '\\');
		if (lpchLastBS != NULL)
		{
			::_tcscpy_s(szProfile, ++lpchLastBS);
			_TCHAR* lpchLastEx = ::_tcsrchr(szProfile, '.');
			if (lpchLastEx != NULL)
			{
				szProfile[int(lpchLastEx - szProfile)] = (_TCHAR)NULL;
				::_tcscat_s(szProfile, FILE_EXT_INI);
				_TCHAR szTmp[MAX_PATH];
				size_t nLen = (size_t)(lpchLastBS - szPath);
				::_tcsncpy_s(szTmp, MAX_PATH, szPath, nLen);
				szTmp[nLen] = (_TCHAR)NULL;
				::_tcscat_s(szTmp, szProfile);
				::_tcscpy_s(szProfile, szTmp);
				bIsProfile = true;
			}
			::_tcscpy_s(szPath, lpchLastBS);
			lpchLastEx = ::_tcsrchr(szPath, '.');
			if (lpchLastEx != NULL)
			{
				szPath[int(lpchLastEx - szPath)] = (_TCHAR)NULL;
				::_tcscat_s(szPath, FILE_EXT_LOG);
				bIsFileName = true;
			}
		}
	}
	if (!bIsProfile)
	{
		::_tcscpy_s(szProfile, FILENAME_INI);
	}
	if (!bIsFileName)
	{
		::_tcscpy_s(szPath, FILENAME_LOG);
	}	
   
	if (fileLog.ResetFileName(szPath) != TRUE)
	{
		::MessageBox(hWnd, ERR_MSG_CANNOTCREATE_LOC, ERR_MSG_CAP_LOC, 
			MB_OK | MB_ICONERROR | MB_SYSTEMMODAL);      
		return FALSE;
	}

	//   SocketClient	
	socketClient.m_pFileLog = &fileLog;
	ReadSettings(szProfile);
  	if (socketClient.m_bAutoStart)
	{
		OnStartClick(hWnd);
	}
 
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	UpdateControls(hWnd);

	/*
	NOTIFYICONDATA nid;
	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.hWnd = hWnd;
	nid.uID = ID_TRAYEVENT;
	nid.uCallbackMessage = WMU_TRAYEVENT;
	nid.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CHATCLIENT));
	_tcscpy_s(nid.szTip, MAX_LEN_TIP, szTitle);
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	Shell_NotifyIcon(NIM_ADD, &nid);
	*/

	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case ID_ACTIONS_PROPS:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_CLNT_PROP), hWnd, Props);
			break;
		case IDM_EXIT:
			OnClose(hWnd);
			DestroyWindow(hWnd);
			break;
		case ID_ACTIONS_CONNECT:
		case IDC_START:
			OnStartClick(hWnd);
			break;
		case ID_ACTIONS_SEND:
		case IDC_SEND:
			OnSendClick(hWnd);
			break;
		case ID_ACTIONS_SHOWLOG:
			fileLog.ShowFile(); 
			break;
		case IDCANCEL:
			OnClose(hWnd);
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		OnClose(hWnd);
		PostQuitMessage(0);
		break;
	case WM_SYSCOMMAND:
		switch (wParam)
		{
		case SC_MINIMIZE:
			ShowInTray(hWnd);
			//::ShowWindow(hWnd, SW_HIDE); //SW_MINIMIZE
			return (INT_PTR)TRUE;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
    case WSA_NETEVENT:
		OnNetEvent(hWnd, message, wParam, lParam);
		break;
	case WMU_TRAYEVENT:
		{
			if (lParam == WM_LBUTTONDBLCLK)
			{
				ReleaseInTray(hWnd);
				//::ShowWindow(hWnd, SW_SHOWNORMAL); 
			}
		}
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK Props(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);

	int wmId, wmEvent;
	switch (message)
	{
	case WM_INITDIALOG:
		{
			BOOL bIsOk = FALSE;
			_TCHAR szRemoteHost[MAX_HOST_LENGTH];
			szRemoteHost[0] = (_TCHAR)NULL;
			int nLen = MAX_HOST_LENGTH;
			bool bRetVal = socketClient.GetRemoteHostName(szRemoteHost, nLen);
			if (bRetVal && nLen > 0)
			{
				bIsOk = ::SetDlgItemText(hDlg, IDC_EDT_HOST, szRemoteHost);
				_ASSERTE(bIsOk == TRUE);
			}
			bIsOk = ::SetDlgItemInt(hDlg, IDC_EDT_PORT, (UINT)socketClient.GetPort(), FALSE);
			_ASSERTE(bIsOk == TRUE);
			bIsOk = ::CheckDlgButton(hDlg, IDC_CHK_AUTOSTART, socketClient.m_bAutoStart ? BST_CHECKED : BST_UNCHECKED);
			_ASSERTE(bIsOk == TRUE);
			HWND hWndApply = GetDlgItem(hDlg, IDM_APPLY);
			::EnableWindow(hWndApply, FALSE);
			HWND hWndHost = GetDlgItem(hDlg, IDC_EDT_HOST);
			HWND hWndPort = GetDlgItem(hDlg, IDC_EDT_PORT);
			#pragma warning(disable : 4244 4312)
			wpOrigProcHost = (WNDPROC)SetWindowLongPtr(hWndHost, 
                GWL_WNDPROC, (LONG_PTR)(LRESULT)EditSubClsProcHost);
			wpOrigProcPort = (WNDPROC)SetWindowLongPtr(hWndPort, 
                GWL_WNDPROC, (LONG_PTR)(LRESULT)EditSubClsProcPort);
			#pragma warning(default : 4244 4312)
		}
		return (INT_PTR)TRUE;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		switch (wmId)
		{
		case IDCANCEL:
			{
				EndDialog(hDlg, LOWORD(wParam));
				return (INT_PTR)TRUE;
			}
			break;
		case IDM_APPLY:
			{
				BOOL bIsOk = FALSE;
				_TCHAR szHost[MAX_HOST_LENGTH];
				szHost[0] = (_TCHAR) NULL;
				int nLen = MAX_HOST_LENGTH;
				UINT nRetVal = ::GetDlgItemText(hDlg, IDC_EDT_HOST, szHost, nLen);
				bool bRetVal = socketClient.SetRemoteHostName(szHost, nLen); 
				_ASSERTE(bRetVal == true);
				bRetVal = socketClient.SetPort((int)::GetDlgItemInt(hDlg, IDC_EDT_PORT, &bIsOk, FALSE));
				_ASSERTE(bIsOk == TRUE);
				if (!bRetVal && socketClient.IsError())
				{
					socketClient.ShowErrorMessage(hDlg); 
				}
				socketClient.m_bAutoStart = (::IsDlgButtonChecked(hDlg, IDC_CHK_AUTOSTART) == BST_CHECKED);
				WriteSettings(szProfile);
				HWND hWndApply = ::GetDlgItem(hDlg, IDM_APPLY);
				::EnableWindow(hWndApply, FALSE);
			}
			break;
		case IDC_CHK_AUTOSTART:
			{
				HWND hWndApply = ::GetDlgItem(hDlg, IDM_APPLY);
				if (::IsWindowEnabled(hWndApply) == FALSE)
				{
					::EnableWindow(hWndApply, TRUE);
				}
			}
			break;
		}
	}
	return (INT_PTR)FALSE;
}

LRESULT APIENTRY EditSubClsProcHost(
    HWND hwnd, 
    UINT uMsg, 
    WPARAM wParam, 
    LPARAM lParam) 
{ 
    if (uMsg == WM_GETDLGCODE)
	{
		MSG* pMSG = (MSG*)lParam;
		if (pMSG != NULL)
		{
			if (pMSG->message == WM_KEYDOWN)
			{
				int nKey = (int)wParam;
				if ((nKey > 47 && nKey < 58) || (nKey > 95 && nKey < 106)
					|| (nKey > 64 && nKey < 123) || nKey == 8 || nKey == 46)
				{
					HWND hDlg = ::GetParent(hwnd);
					HWND hWndApply = ::GetDlgItem(hDlg, IDM_APPLY); 
					if (::IsWindowEnabled(hWndApply) == FALSE)
					{
						::EnableWindow(hWndApply, TRUE);
					}
				}
			}
		}
        return DLGC_WANTALLKEYS;
	}
    return CallWindowProc(wpOrigProcPort, hwnd, uMsg, 
        wParam, lParam); 
}

LRESULT APIENTRY EditSubClsProcPort(
    HWND hwnd, 
    UINT uMsg, 
    WPARAM wParam, 
    LPARAM lParam) 
{ 
    if (uMsg == WM_GETDLGCODE)
	{
		MSG* pMSG = (MSG*)lParam;
		if (pMSG != NULL)
		{
			if (pMSG->message == WM_KEYDOWN)
			{
				int nKey = (int)wParam;
				if ((nKey > 47 && nKey < 58) || (nKey > 95 && nKey < 106)
					|| nKey == 8 || nKey == 46)
				{
					//      
					HWND hDlg = ::GetParent(hwnd);
					HWND hWndApply = ::GetDlgItem(hDlg, IDM_APPLY); 
					if (::IsWindowEnabled(hWndApply) == FALSE)
					{
						::EnableWindow(hWndApply, TRUE);
					}
				}
			}
		}
        return DLGC_WANTALLKEYS;
	}
    return CallWindowProc(wpOrigProcPort, hwnd, uMsg, 
        wParam, lParam); 
}

void InitBuffer()
{
	socketClient.m_BuffMsg[0] = (_TCHAR)NULL;
}

void ShowData(HWND hWnd)
{
	if (::_tcslen(socketClient.m_BuffMsg) > 0)
	{
		HWND lhWnd = ::GetDlgItem(hWnd, IDC_EDT_LOG);
		int nLen = (int)::SendMessage(lhWnd, WM_GETTEXTLENGTH, 0, 0);
		LRESULT lResult = ::SendMessage(lhWnd, EM_SETSEL, (WPARAM)nLen, (LPARAM)nLen);
		lResult = ::SendMessage(lhWnd, EM_REPLACESEL, (WPARAM)FALSE, (LPARAM)&socketClient.m_BuffMsg);
	}
}

void UpdateControls(HWND hWnd)
{
	HMENU hMenu = ::GetMenu(hWnd);
	bool bIsOpen = socketClient.IsOpen();
	if (bIsOpen != (::GetMenuState(hMenu, ID_ACTIONS_CONNECT, MF_BYCOMMAND) == MF_CHECKED))
	{
		::CheckMenuItem(hMenu, ID_ACTIONS_CONNECT, (bIsOpen ? MF_CHECKED : MF_UNCHECKED));
	}
	::EnableMenuItem(hMenu, ID_ACTIONS_SEND, MF_BYCOMMAND | (bIsOpen ? MF_ENABLED : MF_GRAYED));
	::EnableMenuItem(hMenu, ID_ACTIONS_PROPS, MF_BYCOMMAND | (bIsOpen ? MF_GRAYED : MF_ENABLED));
	::EnableMenuItem(hMenu, IDM_ABOUT, MF_BYCOMMAND | (bIsOpen ? MF_GRAYED : MF_ENABLED));

	_TCHAR szText[MAX_CAP_SIZE];
	UINT nSize = ::GetDlgItemText(hWnd, IDC_START, szText, MAX_CAP_SIZE);
	LPCTSTR lpzsCurTxt = (!bIsOpen) ? BTN_CAP_CONNECT : BTN_CAP_DISCONNECT;
	if (::_tcscmp(szText, lpzsCurTxt) != 0)
	{
		::SetDlgItemText(hWnd, IDC_START, lpzsCurTxt);
	}
	HWND lhWnd = ::GetDlgItem(hWnd, IDC_SEND);
	::EnableWindow(lhWnd, (bIsOpen == true));
}

void OnClose(HWND hWnd)
{
	InitBuffer();
	if (!socketClient.Close(hWnd))
	{
		socketClient.ShowErrorMessage(hWnd); 
	}
	ShowData(hWnd);
	ReleaseInTray(hWnd);
}

void OnStartClick(HWND hWnd)
{
	InitBuffer();
	if (!socketClient.IsOpen())
	{
	   if (!socketClient.Initialize(hWnd, 0))
	   {
		  socketClient.ShowErrorMessage(hWnd); 
	   }
	}
	else
	{
	   if (!socketClient.Close(hWnd))
	   {
		  socketClient.ShowErrorMessage(hWnd); 
	   }
	}
	UpdateControls(hWnd);
	ShowData(hWnd);
}

void OnSendClick(HWND hWnd)
{
	InitBuffer();
	_TCHAR szText[MAX_MSG_SIZE];
	UINT nSize = ::GetDlgItemText(hWnd, IDC_EDT_MSG, szText, MAX_MSG_SIZE);
	if (socketClient.Send(szText) == (DWORD)0)
	{
		if (socketClient.IsError())
		{
			socketClient.ShowErrorMessage(hWnd); 
		}
	}
	else
	{
		ShowData(hWnd);
	}
}

void OnNetEvent(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	InitBuffer();
	socketClient.Event_OnWSANet(hWnd, message, wParam, lParam);
	if (socketClient.IsError())
	{
		socketClient.ShowErrorMessage(hWnd); 
	}
	UpdateControls(hWnd);
	ShowData(hWnd);
}

void ReadSettings(LPCTSTR lpszFileName)
{
	_TCHAR szHost[MAX_HOST_LENGTH];
	szHost[0] = (_TCHAR)NULL;
	int nLen = MAX_HOST_LENGTH;
	DWORD dwRetVal = ::GetPrivateProfileString(_T("NetSettings"), 
		_T("Host"), _T(""), szHost, (DWORD)nLen, lpszFileName);
	bool bIsOk = socketClient.SetRemoteHostName(szHost, nLen); 
	bIsOk = socketClient.SetPort((int)::GetPrivateProfileInt(_T("NetSettings"), 
		_T("Port"), SERV_PORT, lpszFileName));
	_ASSERTE(bIsOk == true);
	socketClient.m_bAutoStart = ((BOOL)::GetPrivateProfileInt(_T("NetSettings"), 
		_T("AutoStart"), (int)FALSE, lpszFileName) == TRUE);
}

void WriteSettings(LPCTSTR lpszFileName)
{
	_TCHAR szHost[MAX_HOST_LENGTH];
	szHost[0] = (_TCHAR)NULL;
	int nLen = MAX_HOST_LENGTH;
	bool bRetVal = socketClient.GetRemoteHostName(szHost, nLen); 
	BOOL bIsOk = ::WritePrivateProfileString(_T("NetSettings"), 
		_T("Host"), szHost, lpszFileName);
	_ASSERTE(bIsOk == TRUE);
	_TCHAR szPort[MAX_PORT_LENGTH];
	errno_t err = ::_itow_s(socketClient.GetPort(), szPort, MAX_PORT_LENGTH, 10);
	_ASSERTE(err == 0);
	bIsOk = ::WritePrivateProfileString(_T("NetSettings"), 
		_T("Port"), szPort, lpszFileName);
	_ASSERTE(bIsOk == TRUE);
	bIsOk = ::WritePrivateProfileString(_T("NetSettings"), 
		_T("AutoStart"), socketClient.m_bAutoStart ? _T("1") : _T("0"), lpszFileName);
	_ASSERTE(bIsOk == TRUE);
}

bool ShowInTray(HWND hWnd)
{
	if (::IsWindowVisible(hWnd) == TRUE)
	{
		NOTIFYICONDATA nid;
		nid.cbSize = sizeof(NOTIFYICONDATA);
		nid.hWnd = hWnd;
		nid.uID = ID_TRAYEVENT;
		nid.uCallbackMessage = WMU_TRAYEVENT;
		nid.hIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_CHATCLIENT));
		::_tcscpy_s(nid.szTip, MAX_LEN_TIP, szTitle);
		nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
		if (::Shell_NotifyIcon(NIM_ADD, &nid) == TRUE)
		{
			::ShowWindow(hWnd, SW_HIDE);
			return true;
		}
	}
	return false;
}

bool ReleaseInTray(HWND hWnd)
{
	if (::IsWindowVisible(hWnd) == FALSE)
	{
		// Delete the tray icon
		NOTIFYICONDATA nid;
		nid.cbSize = sizeof(NOTIFYICONDATA);
		nid.hWnd = hWnd;
		nid.uID = ID_TRAYEVENT;
		if (::Shell_NotifyIcon(NIM_DELETE, &nid) == TRUE)
		{
			::ShowWindow(hWnd, SW_SHOWNORMAL);
			return true;
		}
	}
	return false;
}
