// ChatServer.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "FileLog.h"
#include "SocketServer.h"
#include "ChatServer.h"
#include <shellapi.h>

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
_TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
_TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

CFileLog fileLog;
SocketServer socketServer;
HANDLE g_hMutex;
WNDPROC wpOrigEditProc;
_TCHAR szProfile[MAX_PATH];

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

int APIENTRY _tWinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_CHATSERVER, szWindowClass, MAX_LOADSTRING);

	//    
	g_hMutex = ::CreateMutex(NULL, FALSE, NULTEX_NAME);
	if (g_hMutex == NULL)
	{
		return FALSE;
	}
	if (::GetLastError() == ERROR_ALREADY_EXISTS)
	{
		HWND lhWnd = (HWND)NULL;
		lhWnd = ::FindWindow(NULL, szTitle);
		if (lhWnd != (HWND)NULL)
		{
			if (::IsIconic(lhWnd) != 0)
			{
				::ShowWindow(lhWnd, SW_SHOWNOACTIVATE);
			}
			::SetForegroundWindow(lhWnd);
		}
		return FALSE;
	}

	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_CHATSERVER));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	if (NULL != g_hMutex)
	{
		ReleaseMutex(g_hMutex);
		CloseHandle(g_hMutex);
		g_hMutex = NULL;
	}

	return (int) msg.wParam;
}

//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= DLGWINDOWEXTRA;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CHATSERVER));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_GRAYTEXT); //(COLOR_WINDOW+1); COLOR_BTNHIGHLIGHT
	wcex.lpszMenuName	= MAKEINTRESOURCE(IDC_CHATSERVER);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   /*hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);*/
   hWnd = ::CreateDialog(hInstance, MAKEINTRESOURCE(IDD_SERVERDLG), NULL, NULL);
	::SetWindowText(hWnd, szTitle);

   if (!hWnd)
   {
      return FALSE;
   }

   ::_tsetlocale(LC_ALL, LOCAL_LOC);
   ::LoadKeyboardLayout(KLID_LOC, KLF_ACTIVATE);

   //   -   	
   _TCHAR szPath[MAX_PATH];
	bool bIsFileName = false;
	bool bIsProfile = false;
	if (::GetModuleFileName(NULL, szPath, MAX_PATH) != 0)
	{
		_TCHAR* lpchLastBS = ::_tcsrchr(szPath, '\\');
		if (lpchLastBS != NULL)
		{
			::_tcscpy_s(szProfile, ++lpchLastBS);
			_TCHAR* lpchLastEx = ::_tcsrchr(szProfile, '.');
			if (lpchLastEx != NULL)
			{
				szProfile[int(lpchLastEx - szProfile)] = (_TCHAR)NULL;
				::_tcscat_s(szProfile, FILE_EXT_INI);
				_TCHAR szTmp[MAX_PATH];
				size_t nLen = (size_t)(lpchLastBS - szPath);
				::_tcsncpy_s(szTmp, MAX_PATH, szPath, nLen);
				szTmp[nLen] = (_TCHAR)NULL;
				::_tcscat_s(szTmp, szProfile);
				::_tcscpy_s(szProfile, szTmp);
				bIsProfile = true;
			}
			::_tcscpy_s(szPath, lpchLastBS);
			lpchLastEx = ::_tcsrchr(szPath, '.');
			if (lpchLastEx != NULL)
			{
				szPath[int(lpchLastEx - szPath)] = (_TCHAR)NULL;
				::_tcscat_s(szPath, FILE_EXT_LOG);
				bIsFileName = true;
			}
		}
	}
	if (!bIsProfile)
	{
		::_tcscpy_s(szProfile, FILENAME_INI);
	}
	if (!bIsFileName)
	{
		::_tcscpy_s(szPath, FILENAME_LOG);
	}	
	if (fileLog.ResetFileName(szPath) != TRUE)
	{
		::MessageBox(hWnd, ERR_MSG_CANNOTCREATE_LOC, ERR_MSG_CAP_LOC, 
			MB_OK | MB_ICONERROR | MB_SYSTEMMODAL);      
		return FALSE;
	}

	//   SocketServer	
	socketServer.m_pFileLog = &fileLog;
	ReadSettings(szProfile);
	if (socketServer.m_bAutoStart)
	{
		OnStartClick(hWnd);
	}

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);
	UpdateControls(hWnd);
	
	/*
	NOTIFYICONDATA nid;
	nid.cbSize = sizeof(NOTIFYICONDATA);
	nid.hWnd = hWnd;
	nid.uID = ID_TRAYEVENT;
	nid.uCallbackMessage = WMU_TRAYEVENT;
	nid.hIcon = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_CHATSERVER));
	_tcscpy_s(nid.szTip, MAX_LEN_TIP, szTitle);
	nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
	Shell_NotifyIcon(NIM_ADD, &nid);
	*/
	return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case ID_ACTIONS_PROPS:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_SRVR_PROP), hWnd, Props);
			break;
		case IDM_EXIT:
			OnClose(hWnd);
			DestroyWindow(hWnd);
			break;
		case ID_ACTIONS_START:
		case IDC_START:
			OnStartClick(hWnd);
			break;
		case ID_ACTIONS_SEND:
		case IDC_SEND:
			OnSendClick(hWnd);
			break;
		case ID_ACTIONS_SHOWLOG:
			fileLog.ShowFile(); 
			break;
		case IDCANCEL:
			OnClose(hWnd);
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		EndPaint(hWnd, &ps);
		break;
	case WM_DESTROY:
		OnClose(hWnd);
		PostQuitMessage(0);
		break;
	case WM_SYSCOMMAND:
		switch (wParam)
		{
		case SC_MINIMIZE:
			ShowInTray(hWnd);
			return (INT_PTR)TRUE;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
    case WSA_ACCEPT:
		OnAcceptEvent(hWnd, message, wParam, lParam);
		break;
    case WSA_NETEVENT:
		OnNetEvent(hWnd, message, wParam, lParam);
		break;
	case WMU_TRAYEVENT:
		{
			if (lParam == WM_LBUTTONDBLCLK)
			{
				ReleaseInTray(hWnd);
				//::ShowWindow(hWnd, SW_SHOWNORMAL); 
			}
		}
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}

INT_PTR CALLBACK Props(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);

	int wmId, wmEvent;
	switch (message)
	{
	case WM_INITDIALOG:
		{
			BOOL bIsOk = FALSE;
			bIsOk = ::SetDlgItemInt(hDlg, IDC_EDT_PORT, (UINT)socketServer.GetPort(), FALSE);
			_ASSERTE(bIsOk == TRUE);
			bIsOk = ::CheckDlgButton(hDlg, IDC_CHK_AUTOSTART, socketServer.m_bAutoStart ? BST_CHECKED : BST_UNCHECKED);
			_ASSERTE(bIsOk == TRUE);
			HWND hWndApply = GetDlgItem(hDlg, IDM_APPLY);
			::EnableWindow(hWndApply, FALSE);
			HWND hWndEdit = GetDlgItem(hDlg, IDC_EDT_PORT);
//			#pragma warning(disable : 4311 4312)
//			wpOrigEditProc = reinterpret_cast<WNDPROC>(SetWindowLong(hWndEdit, 
//                GWL_WNDPROC, (LONG)EditSubclassProc));
//			#pragma warning(default : 4311 4312)
			#pragma warning(disable : 4244 4312)
			wpOrigEditProc = (WNDPROC)SetWindowLongPtr(hWndEdit, 
                GWL_WNDPROC, (LONG_PTR)(LRESULT)EditSubclassProc);
			#pragma warning(default : 4244 4312)
		}
		return (INT_PTR)TRUE;
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		switch (wmId)
		{
		case IDCANCEL:
			{
				EndDialog(hDlg, LOWORD(wParam));
				return (INT_PTR)TRUE;
			}
			break;
		case IDM_APPLY:
			{
				BOOL bIsOk = FALSE;
				bool bRetVal = socketServer.SetPort((int)::GetDlgItemInt(hDlg, IDC_EDT_PORT, &bIsOk, FALSE));
				_ASSERTE(bIsOk == TRUE);
				if (!bRetVal && socketServer.IsError())
				{
					socketServer.ShowErrorMessage(hDlg); 
				}
				socketServer.m_bAutoStart = (::IsDlgButtonChecked(hDlg, IDC_CHK_AUTOSTART) == BST_CHECKED);
				WriteSettings(szProfile);
				HWND hWndApply = ::GetDlgItem(hDlg, IDM_APPLY);
				::EnableWindow(hWndApply, FALSE);
			}
			break;
		case IDC_CHK_AUTOSTART:
			{
				HWND hWndApply = ::GetDlgItem(hDlg, IDM_APPLY);
				if (::IsWindowEnabled(hWndApply) == FALSE)
				{
					::EnableWindow(hWndApply, TRUE);
				}
			}
			break;
		}
	}
	return (INT_PTR)FALSE;
}

LRESULT APIENTRY EditSubclassProc(
    HWND hwnd, 
    UINT uMsg, 
    WPARAM wParam, 
    LPARAM lParam) 
{ 
    if (uMsg == WM_GETDLGCODE)
	{
		MSG* pMSG = (MSG*)lParam;
		if (pMSG != NULL)
		{
			if (pMSG->message == WM_KEYDOWN)
			{
				int nKey = (int)wParam;
				if (nKey > 47 && nKey < 58 || (nKey > 95 && nKey < 106))
				{
					//      
					HWND hDlg = ::GetParent(hwnd);
					HWND hWndApply = ::GetDlgItem(hDlg, IDM_APPLY); 
					if (::IsWindowEnabled(hWndApply) == FALSE)
					{
						::EnableWindow(hWndApply, TRUE);
					}
				}
			}
		}
        return DLGC_WANTALLKEYS;
	}
    return CallWindowProc(wpOrigEditProc, hwnd, uMsg, 
        wParam, lParam); 
}

void InitBuffer()
{
	socketServer.m_BuffMsg[0] = (_TCHAR)NULL;
}

void ShowData(HWND hWnd)
{
	if (::_tcslen(socketServer.m_BuffMsg) > 0)
	{
		HWND lhWnd = ::GetDlgItem(hWnd, IDC_EDT_LOG);
		_ASSERTE(lhWnd != (HWND)NULL);
		int nLen = (int)::SendMessage(lhWnd, WM_GETTEXTLENGTH, 0, 0);
		LRESULT lResult = ::SendMessage(lhWnd, EM_SETSEL, (WPARAM)nLen, (LPARAM)nLen);
		lResult = ::SendMessage(lhWnd, EM_REPLACESEL, (WPARAM)FALSE, (LPARAM)&socketServer.m_BuffMsg);
	}
}

void OnClose(HWND hWnd)
{
	InitBuffer();
	if (!socketServer.Close(hWnd))
	{
		socketServer.ShowErrorMessage(hWnd); 
	}
	ShowData(hWnd);
	ReleaseInTray(hWnd);
}

void OnStartClick(HWND hWnd)
{
	InitBuffer();
	if (!socketServer.IsOpen())
	{
	   if (!socketServer.Initialize(hWnd, 0))
	   {
		  socketServer.ShowErrorMessage(hWnd); 
	   }
	}
	else
	{
	   if (!socketServer.Close(hWnd))
	   {
		  socketServer.ShowErrorMessage(hWnd); 
	   }
	}
	UpdateControls(hWnd);
	ShowData(hWnd);
}

void OnSendClick(HWND hWnd)
{
	InitBuffer();
	_TCHAR szText[MAX_MSG_SIZE];
	UINT nSize = ::GetDlgItemText(hWnd, IDC_EDT_MSG, szText, MAX_MSG_SIZE);
	DWORD dwCntSend = 0;
	if ((dwCntSend = socketServer.Send(hWnd, szText)) == 0)
	{
		if (socketServer.IsError())
		{
			socketServer.ShowErrorMessage(hWnd); 
		}
		else
		{
			if (socketServer.GetClientsCount() == 0)
			{
				::MessageBox(hWnd, INF_MSG_NOCONNECTIONS_LOC, INF_MSG_CAPTION_LOC,
					MB_OK | MB_ICONINFORMATION | MB_SYSTEMMODAL); 
			}
		}
	}
	else
	{
		ShowData(hWnd);
	}
}

void OnAcceptEvent(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	InitBuffer();
	socketServer.Event_OnWSAAccept(hWnd, message, wParam, lParam);
	if (socketServer.IsError())
	{
		socketServer.ShowErrorMessage(hWnd); 
	}
	ShowData(hWnd);
}

void OnNetEvent(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	InitBuffer();
	socketServer.Event_OnWSANet(hWnd, message, wParam, lParam);
	if (socketServer.IsError())
	{
		socketServer.ShowErrorMessage(hWnd); 
	}
	ShowData(hWnd);
}

void UpdateControls(HWND hWnd)
{
	HMENU hMenu = ::GetMenu(hWnd);
	bool bIsOpen = socketServer.IsOpen();
	if (bIsOpen != (::GetMenuState(hMenu, ID_ACTIONS_START, MF_BYCOMMAND) == MF_CHECKED))
	{
		::CheckMenuItem(hMenu, ID_ACTIONS_START, (bIsOpen ? MF_CHECKED : MF_UNCHECKED));
	}
	::EnableMenuItem(hMenu, ID_ACTIONS_SEND, MF_BYCOMMAND | (bIsOpen ? MF_ENABLED : MF_GRAYED));
	::EnableMenuItem(hMenu, ID_ACTIONS_PROPS, MF_BYCOMMAND | (bIsOpen ? MF_GRAYED : MF_ENABLED));
	::EnableMenuItem(hMenu, IDM_ABOUT, MF_BYCOMMAND | (bIsOpen ? MF_GRAYED : MF_ENABLED));

	_TCHAR szText[MAX_CAP_SIZE];
	UINT nSize = ::GetDlgItemText(hWnd, IDC_START, szText, MAX_CAP_SIZE);
	LPCTSTR lpzsCurTxt = (!bIsOpen) ? BTN_CAP_START : BTN_CAP_STOP;
	if (::_tcscmp(szText, lpzsCurTxt) != 0)
	{
		::SetDlgItemText(hWnd, IDC_START, lpzsCurTxt);
	}
	HWND lhWnd = ::GetDlgItem(hWnd, IDC_SEND);
	::EnableWindow(lhWnd, (bIsOpen == true));
}

void ReadSettings(LPCTSTR lpszFileName)
{
	bool bIsOk = socketServer.SetPort((int)::GetPrivateProfileInt(_T("NetSettings"), 
		_T("Port"), SERV_PORT, lpszFileName));
	_ASSERTE(bIsOk == true);
	socketServer.m_bAutoStart = ((BOOL)::GetPrivateProfileInt(_T("NetSettings"), 
		_T("AutoStart"), (int)FALSE, lpszFileName) == TRUE);
}

void WriteSettings(LPCTSTR lpszFileName)
{
	_TCHAR szPort[MAX_PORT_LENGTH];
	errno_t err = ::_itow_s(socketServer.GetPort(), szPort, MAX_PORT_LENGTH, 10);
	_ASSERTE(err == 0);
	BOOL bIsOk = ::WritePrivateProfileString(_T("NetSettings"), 
		_T("Port"), szPort, lpszFileName);
	_ASSERTE(bIsOk == TRUE);
	bIsOk = ::WritePrivateProfileString(_T("NetSettings"), 
		_T("AutoStart"), socketServer.m_bAutoStart ? _T("1") : _T("0"), lpszFileName);
	_ASSERTE(bIsOk == TRUE);
}

bool ShowInTray(HWND hWnd)
{
	if (::IsWindowVisible(hWnd) == TRUE)
	{
		NOTIFYICONDATA nid;
		nid.cbSize = sizeof(NOTIFYICONDATA);
		nid.hWnd = hWnd;
		nid.uID = ID_TRAYEVENT;
		nid.uCallbackMessage = WMU_TRAYEVENT;
		nid.hIcon = ::LoadIcon(hInst, MAKEINTRESOURCE(IDI_CHATSERVER));
		::_tcscpy_s(nid.szTip, MAX_LEN_TIP, szTitle);
		nid.uFlags = NIF_ICON | NIF_MESSAGE | NIF_TIP;
		if (::Shell_NotifyIcon(NIM_ADD, &nid) == TRUE)
		{
			::ShowWindow(hWnd, SW_HIDE);
			return true;
		}
	}
	return false;
}

bool ReleaseInTray(HWND hWnd)
{
	if (::IsWindowVisible(hWnd) == FALSE)
	{
		// Delete the tray icon
		NOTIFYICONDATA nid;
		nid.cbSize = sizeof(NOTIFYICONDATA);
		nid.hWnd = hWnd;
		nid.uID = ID_TRAYEVENT;
		if (::Shell_NotifyIcon(NIM_DELETE, &nid) == TRUE)
		{
			::ShowWindow(hWnd, SW_SHOWNORMAL);
			return true;
		}
	}
	return false;
}
