#pragma once

#define MAX_HOST_LENGTH		MAX_PATH
#define MAX_PORT_LENGTH		6
#define LO_VERSION_NUMBER	2
#define HI_VERSION_NUMBER	2
#define SERV_PORT			5000 //27015

#define MAX_LEN_PORT	10
#define MAX_LEN_IP		16
#define LEN_BUFF_KEY	MAX_LEN_PORT + 1 + MAX_LEN_IP
#define FRM_BUFF_KEY	_T("%hu:%s")
#define LEN_MSG_HI	7 + LEN_BUFF_KEY
#define FRM_MSG_HI	_T("@Hello %s")

#define FRM_MSG_WIN32 _T("%s    : %d: %s")
#define CAP_MSG_WIN32 _T("")

#define FRM_MSG_WINSOCK1 _T("Error: %lu \r\nMessage: %s")
#define FRM_MSG_WINSOCK2 _T("Error: %lu")
#define CAP_MSG_WINSOCK _T("Error")

#define ERR_MSG_NOMEMORY _T("Insufficient memory available.")

#define RECV_BUFF_SIZE	1024

class SocketBase
{
public:
	SocketBase(void);
	virtual ~SocketBase(void);
	LPCTSTR GetLastErrorMessage(void);
	DWORD GetLastErrorNumber(void);
	bool IsError(void);
	void ShowErrorMessage(HWND hWnd, bool bClear = true);
	virtual bool Initialize(HWND hWnd, int nPort, LPCTSTR lpRemoteHost = NULL);
	virtual bool IsOpen(void);
	virtual bool Close(void);
	int GetPort(void);
	bool SetPort(int nPort);
	CFileLog* m_pFileLog;
	bool GetHostName(LPTSTR lpszHostName, int& nLength);
protected:
	typedef struct _ERROR_MSG_INFO
	{
		DWORD nErrorNumber;
		LPCTSTR lpszErrMessage;
	} ERROR_MSG_INFO, *LPERROR_MSG_INFO;
	static ERROR_MSG_INFO m_error_msg_info[]; 
	WORD m_wVersionRequested;
	WSADATA m_wsaData;
	DWORD m_dwLastErrNumber;
	int m_nPort;
	char m_szHostName[MAX_HOST_LENGTH];
	SOCKET m_socket;
	SOCKADDR_IN m_socket_arrd;
	bool Startup(void);
	bool CreateSocket(void);
	bool WriteLog(LPCTSTR lpszMsg);
	int GetSocketKey(LPTSTR lpszKey, LPSOCKADDR_IN lpSockAddr);
	void ShowWin32Err(LPCTSTR lpszFunction);
};